#include "timing_logic.h"
#include "user_interface.h"
#include "communications.h"
#include "body_temperature.h"
#include "clock.h"
#include "timer.h"

void slowPeriodicFunction(void);
void fastPeriodicFunction(void);

volatile int prueba_slow;
volatile int prueba_fast;

static int bluetoothTransmissionEnable = 0;

void initializeTimingLogic(void)
{
    configureClockSystem();
    configureTimer();
    setSlowFunctionISRCallbackFunction(slowPeriodicFunction);
    setFastFunctionISRCallbackFunction(fastPeriodicFunction);
}

void startBluetoothTransmission(void)
{
    bluetoothTransmissionEnable = 1;
}

unsigned int getCurrentMilisecondsTime(void)
{
    return getCurrentTime();
}

void slowPeriodicFunction(void)
{
    runADCConversion();

    if(bluetoothTransmissionEnable == 1)
    {
        sendBtPacket();
    }

    if(prueba_slow == 0)
    {
        turnOnAlarmLED();
        prueba_slow = 1;
    }
    else
    {
        turnOffAlarmLED();
        prueba_slow = 0;
    }
}

void fastPeriodicFunction(void)
{
    if(prueba_fast == 0)
    {
        turnOnDebugLED();
        prueba_fast = 1;
    }
    else
    {
        turnOffDebugLED();
        prueba_fast = 0;
    }
}
